// jpnslisp.h (for gcc)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
//#include <alloc.h>
#include <math.h>
#include <limits.h>
#include <time.h>

#define LINE_BUF_SIZE 256
#define BUFLEN 20000
#define FALSE 0
#define TRUE 1
#define CELL_SIZE 3200000L
#define STRING_SIZE 320000L
#define STRING_NUM 100000L
#define NUMBER_SIZE 1600000L
#define INT_SIZE 1600000L
#define GLOBAL_SIZE 3200L
#define FUNCTION_SIZE 3200L
#define READ_EVAL_NUM 41
#define FILE_POINTER_LEN 10
#define PATH_LEN 256

#define CELL_STACK_SIZE 32000000L
#define LOC_STACK_SIZE 32000000L
#define STATIC_STACK_SIZE 32000L

#define CELL_SIZE_MIN 1000L
#define NUMBER_SIZE_MIN 1000L
#define INT_SIZE_MIN 1000L

#define XORSHIFT_MAX (ULONG_MAX / 10)

typedef int BOOL;

struct _afloat {
	char gc;
	/*long*/ double f;
};

typedef struct _afloat AFLOAT;

struct _aint {
	char gc;
	long f;
};

typedef struct _aint AINT;

struct _cell {
	char attr;  // n:_Ai:As:V{Al:XgiRXZjAb:Am:Ar:Aa:z
        char attr2; // u:ʏAc:RŎn܂V{
	char gc;
//        char returnflag; // ʏu
	struct _cell *car;
	struct _cell *cdr;
        struct _cell *mtop;  // lp@ʏNULL
	struct _symval *clj;
	long cljlen;
};

typedef struct _cell CELL;

struct _symval {
	char attr;
	CELL *sym;  // attrs̃Z
	CELL *val;
};

typedef struct _symval SYMVAL;

void printS(CELL *);
void printS2(CELL *,BOOL);
void printS3(CELL *);
void princS(CELL *,FILE *);
void princS2(CELL *,BOOL,FILE *);
void princS3(CELL *,FILE *);
void printSStrm(CELL *,FILE *);
void printS2Strm(CELL *,BOOL,FILE *);
void printS3Strm(CELL *,FILE *);
CELL *eval(CELL *,SYMVAL *,long,long);

CELL *getCell(void);
CELL *SetArray(CELL *,SYMVAL *,long,long);
//CELL *aref(CELL *,SYMVAL *,long);
//CELL *prearef(CELL *,SYMVAL *,long);
CELL *ArrayCar(CELL *);
CELL *ArrayCdr(CELL *);

CELL *getMojiretsuCell(char *);
CELL *getMojiCell(char c1,   // A܂̓VtgihrR[hPoCg
		  char c2 ); // VtgihrR[hQoCg
int isKanji(unsigned char *);
AINT *getInt(long);
CELL *topen(CELL *,SYMVAL *,long,long);
CELL *SetFilePointer(FILE *);
void PutString(CELL *,FILE *);  // a = (#\h #\e #\l #\l #\o) etc.
void PutStringC(CELL *,FILE *);  // a = (#\h #\e #\l #\l #\o) etc.
CELL *ReadLine(void);
void slide(char *,int);
CELL *StringEqual(CELL *,CELL *);
CELL *coerce(CELL *,SYMVAL *,long,long);
CELL *Copy(CELL *);
CELL *tchar(CELL *,SYMVAL *,long,long);
CELL *Random(CELL *,SYMVAL *,long,long);
AFLOAT *getNumber(/*long*/ double);

CELL *jSqrt(CELL *,SYMVAL *,long,long);
CELL *jExpt(CELL *,CELL *,SYMVAL *,long,long);
CELL *jExp(CELL *,SYMVAL *,long,long);
CELL *jLog(CELL *,SYMVAL *,long,long);
CELL *jSin(CELL *,SYMVAL *,long,long);
CELL *jCos(CELL *,SYMVAL *,long,long);
CELL *jTan(CELL *,SYMVAL *,long,long);
CELL *jAsin(CELL *,SYMVAL *,long,long);
CELL *jAcos(CELL *,SYMVAL *,long,long);
CELL *jAtan(CELL *,SYMVAL *,long,long);

CELL *jEvenp(CELL *,SYMVAL *,long,long);

CELL *IncCellStack(CELL *);
void PopCellStack(void);

CELL *Sa(CELL *,CELL *);

CELL *tfloor(CELL *,SYMVAL *,long,long);

long getLocal(SYMVAL *,long,CELL *,long);

void DumpSymval(SYMVAL *,long);

CELL *now(void);
CELL *LocalTime(CELL *,SYMVAL *,long,long);
CELL *MakeTime(CELL *,SYMVAL *,long,long);

CELL *catch_lisp(CELL *p,SYMVAL *loc,long locn);
CELL *throw_lisp(CELL *p,SYMVAL *loc,long locn);

#pragma GCC diagnostic ignored "-Wint-to-pointer-cast"
#pragma GCC diagnostic ignored "-Wint-conversion"
#pragma GCC diagnostic ignored "-Wpointer-to-int-cast"
